!(function () {
    // 老的浏览器可能根本没有实现 mediaDevices，所以我们可以先设置一个空的对象
    if (navigator.mediaDevices === undefined) {
        navigator.mediaDevices = {};
    }
    if (navigator.mediaDevices.getUserMedia === undefined) {
        navigator.mediaDevices.getUserMedia = function (constraints) {
            // 首先，如果有getUserMedia的话，就获得它
            var getUserMedia = navigator.webkitGetUserMedia || navigator.mozGetUserMedia || navigator.msGetUserMedia;

            // 一些浏览器根本没实现它 - 那么就返回一个error到promise的reject来保持一个统一的接口
            if (!getUserMedia) {
                return Promise.reject(new Error('getUserMedia is not implemented in this browser'));
            }

            // 否则，为老的navigator.getUserMedia方法包裹一个Promise
            return new Promise(function (resolve, reject) {
                getUserMedia.call(navigator, constraints, resolve, reject);
            });
        }
    }
    const constraints = {
        video: true,
        audio: false
    };
    let promise = navigator.mediaDevices.getUserMedia(constraints);
    promise.then(stream => {
        let v = document.getElementById('v');
        console.log("11111");
        // 旧的浏览器可能没有srcObject
        if ("srcObject" in v) {
            v.srcObject = stream;
        } else {
            // 防止再新的浏览器里使用它，应为它已经不再支持了
            v.src = window.URL.createObjectURL(stream);
        }
        v.onloadedmetadata = function (e) {
            v.play();
            var delayInMilliseconds = 1; //1 second

            setTimeout(function () {
                console.log("waited...");
                //your code to be executed after 1 second
                let cap = new cv.VideoCapture(v);
                v.height = v.videoHeight;
                v.width = v.videoWidth;
                console.log(v.height, v.width);  // this outputs 480,640

                let src = new cv.Mat(v.height, v.width, cv.CV_8UC4);
                let dst = new cv.Mat(v.height, v.width, cv.CV_8UC1);
                let gray = new cv.Mat();
                // let src = new cv.Mat(v.offsetHeight || v.height, v.offsetWidth || v.width, cv.CV_8UC4);
                // let dst = new cv.Mat(v.offsetHeight || v.height, v.offsetWidth || v.width, cv.CV_8UC1);
                // let gray = new cv.Mat();
                // let cap = new cv.VideoCapture(v);
                console.log("we are here already!!");
                let faces = new cv.RectVector();
                let classifier = new cv.CascadeClassifier();
                // let utils = new Utils('errorMessage');

                // load pre-trained classifiers
                // console.log(cv2.data.haarcascades);
                // classifier.load('/haarcascade_frontalface_default.xml');
                let faceCascadeFile = './haarcascade_frontalface_default.xml'; // path to xml
                createFileFromUrl(faceCascadeFile, faceCascadeFile, () => {
                    classifier.load(faceCascadeFile); // in the callback, load the cascade from file 
                });
                // classifier.load(document.getElementById('xml-model'));
                // var loc = window.location.pathname;
                // var dir = loc.substring(0, loc.lastIndexOf('/'));
                // console.log(dir);
                // console.log('Current directory: ' + process.cwd());
                // classifier.load('/Library/Frameworks/Python.framework/Versions/3.9/lib/python3.9/site-packages/cv2/data/haarcascade_frontalface_default.xml');

                const FPS = 30;
                function processVideo() {
                    try {
                        // if (!streaming) {
                        //     // clean and stop.
                        //     src.delete();
                        //     dst.delete();
                        //     gray.delete();
                        //     faces.delete();
                        //     classifier.delete();
                        //     return;
                        // }
                        let begin = Date.now();
                        // start processing.
                        cap.read(src);
                        src.copyTo(dst);
                        cv.cvtColor(dst, gray, cv.COLOR_RGBA2GRAY, 0);
                        // detect faces.
                        classifier.detectMultiScale(gray, faces, 1.1, 3, 0);
                        // draw faces.
                        for (let i = 0; i < faces.size(); ++i) {
                            let face = faces.get(i);
                            let point1 = new cv.Point(face.x, face.y);
                            let point2 = new cv.Point(face.x + face.width, face.y + face.height);
                            cv.rectangle(dst, point1, point2, [255, 0, 0, 255]);
                        }
                        cv.imshow('canvasOutput', dst);
                        // schedule the next one.
                        let delay = 1000 / FPS - (Date.now() - begin);
                        setTimeout(processVideo, delay);
                    } catch (err) {
                        // utils.printError(err);
                        console.log(err);
                    }
                };

                // schedule the first one.
                setTimeout(processVideo, 0);
            }, delayInMilliseconds);

        };
    }).catch(err => {
        console.error(err.name + ": " + err.message);
    })
})();

function createFileFromUrl(path, url, callback) {
    let request = new XMLHttpRequest();
    request.open('GET', url, true);
    request.responseType = 'arraybuffer';
    request.onload = function (ev) {
        if (request.readyState === 4) {
            if (request.status === 200) {
                let data = new Uint8Array(request.response);
                cv.FS_createDataFile('/', path, data, true, false, false);
                callback();
            } else {
                self.printError('zhuoyue-Failed to load ' + url + ' status: ' + request.status);
            }
        }
    };
    request.send();
};
